#import "GRController.h"
#import <Carbon/Carbon.h>

@implementation GRController
- (id)init
{
    if (self = [super init]) {
		/*
		// Initialize table data.
        entries = [[NSMutableArray alloc] initWithCapacity:10];
        titles = [[NSMutableArray alloc] initWithCapacity:10];
        authors = [[NSMutableArray alloc] initWithCapacity:10];
		
		// Open speech channel.
		OSErr err = NewSpeechChannel(NULL, &fCurSpeechChannel);
		if (err != noErr) return nil;
		*/
    }
    return self;
}

- (void)dealloc
{
	/*
	// Release table data.
    [entries release];
    [titles release];
    [authors release];
	
	// Dispose of speech channel.
	DisposeSpeechChannel(fCurSpeechChannel);
	*/
}

- (IBAction)search:(id)sender
{
    // Grab the author and title.
    NSCharacterSet *trimSet = [NSCharacterSet whitespaceAndNewlineCharacterSet];
    NSString *author = [[authorField stringValue]
        stringByTrimmingCharactersInSet:trimSet];
    NSString *title = [[titleField stringValue]
        stringByTrimmingCharactersInSet:trimSet];

	// Encode the author and title for URL use.
	author = [GRController encode:author];
	title = [GRController encode:title];
    
    // If both author and title are empty, beep.
    if ([author isEqualToString:@""] && [title isEqualToString:@""]) {
        NSBeep();
        return;
    }
	
	/*
	// Start the progress indicator.
	[progress startAnimation:self];
    
    // Search.
    NSString *query = [NSString stringWithFormat:@"http://gutenberg.net/cgi-bin/search/t9.cgi?whole=yes&ftpsite=http://www.ibiblio.org/gutenberg&author=%@&title=%@", author, title];
    NSURL *url = [NSURL URLWithString:query];
    NSString *html = [NSString stringWithContentsOfURL:url];
    
    // Clear results.
    [entries removeAllObjects];
    [titles removeAllObjects];
    [authors removeAllObjects];
    
    // Parse search results.
    NSRange searchRange = NSMakeRange(0, [html length]);
    while (true) {
        // Grab the entry.
        NSString *marker = @"entry=";
        int index = [GRController indexOf:marker within:html withRange:searchRange];
        if (index == NSNotFound) break;
        NSString *entry = [GRController readFrom:(index + [marker length])
                                     untilString:@"&"
                                          within:html
                                       remaining:&searchRange];
        if (entry == nil) break;
        
        // Grab the title.
        marker = @"<span class=\"title\">";
        index = [GRController indexOf:marker within:html withRange:searchRange];
        if (index == NSNotFound) break;
        NSString *title = [GRController readFrom:(index + [marker length])
                                     untilString:@"</span>"
                                          within:html
                                       remaining:&searchRange];
        if (title == nil) break;
        
        // Grab the author.
        marker = @"<span class=\"author\">";
        index = [GRController indexOf:marker within:html withRange:searchRange];
        if (index == NSNotFound) break;
        NSString *author = [GRController readFrom:(index + [marker length])
                                      untilString:@"</span>"
                                           within:html
                                        remaining:&searchRange];
        if (author == nil) break;
        
        // Save the result.
        [entries addObject:entry];
        [titles addObject:title];
        [authors addObject:author];
    }
	
	// Stop the progress indicator.
	[progress stopAnimation:self];
    
    // Reload the data.
    [resultsTableView reloadData];
	*/
}

- (IBAction)speak:(id)sender
{
	/*
	OSErr err;
	
	// If speaking, stop.
	if ([[sender title] isEqualToString:@"Stop"]) {
		err = StopSpeech(fCurSpeechChannel);
		if (err != noErr) {
			NSRunAlert(@"Error", @"Error #%d returned.", @"OK", nil, nil, err);
		}
		[sender setTitle:@"Speak"];
		return;
	}
	
	// Grab the selected text, or all the text if none selected.
	NSString *text = [[contentTextView textStorage] string];
	NSRange selectedRange = [contentTextView selectedRange];
	if (selectedRange.location != NSNotFound && selectedRange.length != 0) {
		text = [text substringWithRange:selectedRange];
	}
	
	// Convert to cString.
	const char *textToSpeak = [text lossyCString];
	if (textToSpeak != nil) {
		err = SpeakText(fCurSpeechChannel, textToSpeak, strlen(textToSpeak));
		if (err != noErr) {
			NSRunAlertPanel(@"Error", @"Error #%d returned.", @"OK", nil, nil, err);
		}
	}
	
	// Change button name to stop.
	[sender setTitle:@"Stop"];
	*/
}

- (void)resize
{
    // Grab view frames.
    NSRect boxFrame = [searchBox frame];
    NSRect authorFrame = [authorView frame];
    NSRect titleFrame = [titleView frame];
    
    // Resize and place views.
    float halfWidth = NSWidth(boxFrame) / 2;
    [authorView setFrame:NSMakeRect(20, 20, halfWidth - 30, NSHeight(authorFrame))];
    [titleView setFrame:NSMakeRect(halfWidth + 10, 20, halfWidth - 40, NSHeight(titleFrame))];
    
    // Refresh the display.
    [searchBox setNeedsDisplay:YES];
}

- (void)displaySelectedRow
{
	/*
    // Grab the selected row's entry.
    int row = [resultsTableView selectedRow];
    if (row < 0 || row >= [entries count]) return;
    NSString *entry = [entries objectAtIndex:row];
	
	// Start the progress indicator.
	[progress startAnimation:self];
    
    // Build search query.
    NSString *query = [NSString stringWithFormat:@"http://www.gutenberg.net/gutenberg/cgi-bin/search/t9.cgi?entry=%@&full=yes&ftpsite=http://www.ibiblio.org/gutenberg/", entry];
    NSURL *url = [NSURL URLWithString:query];
    NSString *html = [NSString stringWithContentsOfURL:url];
    
    // Grab the text URL.
    NSAttributedString *data = nil;
NS_DURING
    // Find the start of the files list.
    NSRange searchRange = NSMakeRange(0, [html length]);
    NSString *marker = @"<ul class=\"files\">";
    int index = [GRController indexOf:marker within:html withRange:searchRange];
    if (index == NSNotFound) {
        [NSException raise:@"FileNotFoundException"
                    format:@"Could not locate start of \"files\"."];
    }
    
    // Find the text file.
    while (true) {
        // Find the beginning of the anchor.
        int location = index + [marker length];
        searchRange = NSMakeRange(location, [html length] - location);
        marker = @"<a href=\"";
        index = [GRController indexOf:marker within:html withRange:searchRange];
        if (index == NSNotFound) {
            [NSException raise:@"FileNotFoundException"
                        format:@"Could not locate an HTML anchor."];
        }
        
        // Grab the document link.
        NSString *link = [GRController readFrom:(index + [marker length])
                                    untilString:@"\""
                                         within:html remaining:&searchRange];
        if (link == nil) continue;
        
        // Attempt to decode the document.
        NSURL *url = [NSURL URLWithString:link];
		NSString *text = [NSString stringWithContentsOfURL:url];
		if (text == nil) continue;
        data = [[NSAttributedString alloc] initWithString:text];
		break;
    }
NS_HANDLER
    if ([[localException name] isEqualToString:@"FileNotFoundException"]) {
        NSRunAlertPanel(@"Error", @"%@", @"OK", nil, nil, localException);
    }
NS_ENDHANDLER
        
    // Display the content.
    [[contentTextView textStorage] setAttributedString:data];
    [data release];
	
	// Stop the progress indicator.
	[progress stopAnimation:self];
	*/
}

- (void)awakeFromNib
{
	/*
    // Assign self as the data source for the results table.
    [resultsTableView setDataSource:self];
    
    // Set the single-click action for the results table.
    [resultsTableView setTarget:self];
    [resultsTableView setAction:@selector(displaySelectedRow)];
	*/
    
    // Resize myself as it may be necessary.
    [self resize];
    
    // Whenever the window box resizes, resize myself.
    NSNotificationCenter *center = [NSNotificationCenter defaultCenter];
    [center addObserver:self selector:@selector(resize) name:NSViewFrameDidChangeNotification object:searchBox];
}

- (int)numberOfRowsInTableView:(NSTableView *)aTableView
{
	/*
    return [entries count];
	*/
	return 0;
}

- (id)tableView:(NSTableView *)aTableView objectValueForTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex
{
	/*
    NSString *identifier = [aTableColumn identifier];
    if ([identifier isEqualToString:@"author"]) {
        return [[[authors objectAtIndex:rowIndex] retain] autorelease];
    } else if ([identifier isEqualToString:@"title"]) {
        return [[[titles objectAtIndex:rowIndex] retain] autorelease];
    } else {
        return @"";
    }
	*/
	return @"";
}

+ (NSString *)encode:(NSString *)string
{
	// Setup character set.
	NSMutableCharacterSet *safeSet = [[NSMutableCharacterSet alloc] init];
	[safeSet formUnionWithCharacterSet:[NSCharacterSet alphanumericCharacterSet]];
	[safeSet addCharactersInString:@"$&+,/:;=?@"];
	
	// Encode string.
	NSMutableString *encodedString = [NSMutableString stringWithCapacity:[string length]];
	const char *utfString = [string UTF8String];
	int i = 0;
	while (utfString[i] != 0) {
		if ([safeSet characterIsMember:utfString[i]]) {
			[encodedString appendString:[NSString stringWithFormat:@"%c", utfString[i]]];
		} else {
			[encodedString appendString:[NSString stringWithFormat:@"%%%X", utfString[i]]];
		}
		i++;
	}
	[safeSet release];
	
	// Return encoded string.
	return [[[NSString alloc] initWithString:encodedString] autorelease];
}

+ (int)indexOf:(NSString *)string within:(NSString *)content withRange:(NSRange)searchRange
{
    // If the search string is empty, do nothing.
    if (string == nil || [string isEqualToString:@""]) {
        return NSNotFound;
    }
    
    // Find the next occurrence of the search string.
    NSRange range = [content rangeOfString:string options:NSLiteralSearch range:searchRange];
    return range.location;
}

+ (NSString *)readFrom:(int)location untilString:(NSString *)string within:(NSString *)content remaining:(NSRangePointer)range
{
    // If the end string is empty, return the remaining content.
    if (string == nil || [string isEqualToString:@""]) {
        return [content substringFromIndex:location];
    }
    
    // Find the first occurrence of the end string after the starting location.
    NSRange searchRange = NSMakeRange(location, [content length] - location);
    int index = [GRController indexOf:string within:content withRange:searchRange];
    
    // If the end string is not found, return nil and invalidate the remaining range.
    if (index == NSNotFound) {
        if (range != nil) *range = NSMakeRange(NSNotFound, 0);
        return nil;
    }
    
    // Otherwise update the remaining range and return the string.
    int remainingIndex = index + [string length];
    if (range != nil) *range = NSMakeRange(remainingIndex, [content length] - remainingIndex);
    return [content substringWithRange:NSMakeRange(location, index - location)];
}

@end